/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: optgdlg.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/07 16:28:05 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _OFA_OPTGDLG_HXX
#define _OFA_OPTGDLG_HXX

#ifndef _SV_LSTBOX_HXX //autogen wg. ListBox
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_GROUP_HXX //autogen wg. FixedLine
#include <vcl/group.hxx>
#endif
#ifndef _SV_FIELD_HXX //autogen wg. NumericField
#include <vcl/field.hxx>
#endif
#ifndef _SV_FIXED_HXX //autogen wg. FixedText
#include <vcl/fixed.hxx>
#endif
#ifndef _SFXTABDLG_HXX
#include <bf_sfx2/tabdlg.hxx>
#endif
#ifndef _SVX_LANGBOX_HXX
#include <bf_svx/langbox.hxx>
#endif
#define FOLDERWEBVIEW_DEFAULTFILE	"folder.so"
namespace binfilter {

// class OfaMiscTabPage --------------------------------------------------

//STRIP001 class OfaMiscTabPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	FixedLine           aGbTwoFigure;
//STRIP001 	FixedText			aFtInterpret;
//STRIP001 	NumericField		aNfYearValue;
//STRIP001 	FixedText			aFtTo;
//STRIP001 
//STRIP001 	FixedLine           aHelpAgentFL;
//STRIP001 	CheckBox            aHelpAgentCB;
//STRIP001 	FixedText           aHelpAgentTimeFT;
//STRIP001 	NumericField		aHelpAgentTimeED;
//STRIP001 	FixedText           aHelpAgentTimeUnitFT;
//STRIP001 	FixedText			aHelpAgentResetFT;
//STRIP001 	PushButton          aHelpAgentResetBtn;
//STRIP001 
//STRIP001     FixedLine           aHelpFormattingFL;
//STRIP001     FixedText           aStyleSheetFT;
//STRIP001     ListBox             aStyleSheetLB;
//STRIP001 
//STRIP001     FixedLine           aFileDlgFL;
//STRIP001 	CheckBox            aFileDlgCB;
//STRIP001 
//STRIP001     FixedLine           aDocStatusFL;
//STRIP001     CheckBox            aDocStatusCB;
//STRIP001 
//STRIP001     String              aStrDateInfo;
//STRIP001 
//STRIP001 	DECL_LINK( TwoFigureHdl, NumericField* );
//STRIP001 	DECL_LINK( TwoFigureConfigHdl, NumericField* );
//STRIP001 	DECL_LINK( HelpAgentHdl_Impl, CheckBox* );
//STRIP001 	DECL_LINK( HelpAgentResetHdl_Impl, PushButton* );
//STRIP001 protected:
//STRIP001 	virtual int         DeactivatePage( SfxItemSet* pSet = NULL );
//STRIP001 
//STRIP001 public:
//STRIP001 	OfaMiscTabPage( Window* pParent, const SfxItemSet& rSet );
//STRIP001 	~OfaMiscTabPage();
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
//STRIP001 
//STRIP001 	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 		Reset( const SfxItemSet& rSet );
//STRIP001 };

// class OfaViewTabPage --------------------------------------------------

typedef enum {
	LookStardivision = 0,
	LookMotif,
	LookWindows,
	LookOSTwo,
	LookMacintosh
} SystemLook;

typedef enum {
    SnapToButton = 0,
    SnapToMiddle,
    NoSnap
} SnapType;

typedef enum { // MUST match the order chosen in ListBox LB_DRAG_MODE in optgdlg.src
	DragFullWindow,
	DragFrame,
	DragSystemDep
} DragMode;

//STRIP001 class OfaViewTabPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	FixedLine		aAppearanceGB;
//STRIP001 	FixedText		aAppearanceFT;
//STRIP001 	ListBox			aAppearanceLB;
//STRIP001 	FixedText		aScalingFT;
//STRIP001 	MetricField		aScalingMF;
//STRIP001 	FixedText		aBigFT;
//STRIP001 	ListBox			aBigLB;
//STRIP001 	CheckBox		aStyleCB;
//STRIP001 #if defined( UNX ) || defined ( FS_PRIV_DEBUG )
//STRIP001 	CheckBox		aFontAntiAliasing;
//STRIP001 	FixedText		aAAPointLimitLabel;
//STRIP001 	NumericField	aAAPointLimit;
//STRIP001 	FixedText		aAAPointLimitUnits;
//STRIP001 #endif
//STRIP001 
//STRIP001 	CheckBox		aMouseFollowCB;
//STRIP001 	CheckBox		aFlatTabCtrlCB;
//STRIP001 	CheckBox		aColorTabCtrlCB;
//STRIP001 	CheckBox		aFontShowCB;
//STRIP001 	CheckBox		aShowInactiveItemsCB;
//STRIP001 	CheckBox		aFontHistoryCB;
//STRIP001 	CheckBox		aMenuIconsCB;
//STRIP001 
//STRIP001 	FixedLine		aWorkingSetBox;
//STRIP001 	CheckBox		aDocViewBtn;
//STRIP001 	CheckBox		aOpenWinBtn;
//STRIP001 
//STRIP001 	FixedLine		a3DGB;
//STRIP001 	CheckBox		a3DOpenGLCB;
//STRIP001 	CheckBox		a3DOpenGLFasterCB;
//STRIP001 	CheckBox		a3DDitheringCB;
//STRIP001 	CheckBox		a3DShowFullCB;
//STRIP001 
//STRIP001 	FixedLine		aMouseFL;
//STRIP001 	FixedText		aMousePosFT;
//STRIP001 	ListBox			aMousePosLB;
//STRIP001 	FixedText		aMouseMiddleFT;
//STRIP001 	ListBox			aMouseMiddleLB;
//STRIP001 
//STRIP001 	UINT16			nBigLB_InitialSelection;
//STRIP001 	BOOL			bSfxSymbolsAuto;
//STRIP001 
//STRIP001     DECL_LINK( OpenGLHdl, CheckBox* );
//STRIP001 #if defined( UNX ) || defined ( FS_PRIV_DEBUG )
//STRIP001 	DECL_LINK( OnAntialiasingToggled, void* );
//STRIP001 #endif
//STRIP001 public:
//STRIP001 	OfaViewTabPage( Window* pParent, const SfxItemSet& rSet );
//STRIP001 	~OfaViewTabPage();
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
//STRIP001 
//STRIP001 	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 		Reset( const SfxItemSet& rSet );
//STRIP001 };
/* -----------------------------23.11.00 13:04--------------------------------

 ---------------------------------------------------------------------------*/
//class LanguageConfig_Impl;
//STRIP001 class OfaLanguagesTabPage : public SfxTabPage
//STRIP001 {
//STRIP001     FixedLine       aUILanguageGB;
//STRIP001 //	FixedText       aUILanguageFT;
//STRIP001 //	SvxLanguageBox  aUILanguageLB;
//STRIP001     FixedText       aLocaleSettingFT;
//STRIP001     SvxLanguageBox  aLocaleSettingLB;
//STRIP001     FixedText       aCurrencyFT;
//STRIP001     ListBox         aCurrencyLB;
//STRIP001 
//STRIP001     FixedLine       aLinguLanguageGB;
//STRIP001 	FixedText		aWesternLanguageFT;
//STRIP001 	SvxLanguageBox	aWesternLanguageLB;
//STRIP001 	FixedText		aAsianLanguageFT;
//STRIP001 	SvxLanguageBox	aAsianLanguageLB;
//STRIP001 	FixedText		aComplexLanguageFT;
//STRIP001 	SvxLanguageBox	aComplexLanguageLB;
//STRIP001     CheckBox        aCurrentDocCB;
//STRIP001     FixedLine       aAsianSupportFL;
//STRIP001     CheckBox        aAsianSupportCB;
//STRIP001     FixedLine       aCTLSupportFL;
//STRIP001     CheckBox        aCTLSupportCB;
//STRIP001 
//STRIP001 	sal_Bool		m_bOldAsian;
//STRIP001 	sal_Bool		m_bOldCtl;
//STRIP001 // 	LanguageConfig_Impl*    pLangConfig;
//STRIP001 
//STRIP001     DECL_LINK(  SupportHdl, CheckBox* ) ;
//STRIP001     DECL_LINK(  LocaleSettingHdl, SvxLanguageBox* ) ;
//STRIP001 
//STRIP001 public:
//STRIP001 	OfaLanguagesTabPage( Window* pParent, const SfxItemSet& rSet );
//STRIP001 	~OfaLanguagesTabPage();
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
//STRIP001 
//STRIP001 	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 		Reset( const SfxItemSet& rSet );
//STRIP001 };
/* -----------------------------20.06.01 16:32--------------------------------

 ---------------------------------------------------------------------------*/
#ifdef WNT
#else
#define HELPER_PAGE_COMPLETE
#endif

struct OfaHelperProgramsTabPage_Impl;
//STRIP001 class OfaHelperProgramsTabPage : public SfxTabPage
//STRIP001 {
//STRIP001     FixedText       aHelpFI;
//STRIP001 
//STRIP001     FixedLine       aMailFL;
//STRIP001     FixedText       aProgramFT;
//STRIP001     FixedText       aAdditionalMailFT;
//STRIP001     ListBox         aProfilesLB;
//STRIP001     Edit            aMailerURLED;
//STRIP001     PushButton      aMailerURLPB;
//STRIP001 
//STRIP001     FixedLine       aLinkFL;
//STRIP001     FixedText       aHTTPFT;
//STRIP001     Edit            aHTTPED;
//STRIP001     PushButton      aHTTPPB;
//STRIP001 
//STRIP001     FixedText       aHTTPSFT;
//STRIP001     Edit            aHTTPSED;
//STRIP001     PushButton      aHTTPSPB;
//STRIP001 
//STRIP001     FixedText       aFTPFT;
//STRIP001     Edit            aFTPED;
//STRIP001     PushButton      aFTPPB;
//STRIP001 
//STRIP001     FixedText       aMailerFT;
//STRIP001     Edit            aMailerED;
//STRIP001     PushButton      aMailerPB;
//STRIP001 
//STRIP001     FixedLine       aDocManagerFL;
//STRIP001     FixedText       aDocManagerFT;
//STRIP001     Edit            aDocManagerED;
//STRIP001     PushButton      aDocManagerPB;
//STRIP001 
//STRIP001 	String			m_sMozilla;
//STRIP001 	String			m_sNetscape;
//STRIP001 	String			m_sDefaultFilterName;
//STRIP001 
//STRIP001     OfaHelperProgramsTabPage_Impl* pImpl;
//STRIP001 
//STRIP001     DECL_LINK(  FileDialogHdl_Impl, PushButton* ) ;
//STRIP001     DECL_LINK(  ProfileHdl_Impl, ListBox* ) ;
//STRIP001 
//STRIP001 public:
//STRIP001     OfaHelperProgramsTabPage( Window* pParent, const SfxItemSet& rSet );
//STRIP001     ~OfaHelperProgramsTabPage();
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
//STRIP001 
//STRIP001 	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 		Reset( const SfxItemSet& rSet );
//STRIP001 };
} //namespace binfilter
#endif // #ifndef _OFA_OPTGDLG_HXX


