/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sw_wizltdlg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 07:20:07 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/


#pragma hdrstop


#ifndef _SV_PRINT_HXX //autogen
#include <vcl/print.hxx>
#endif


#include "swtypes.hxx"
#include "uitool.hxx"
#include "wizmulti.hxx"
#include "wizard.hrc"
#include "wizltdlg.hxx"
namespace binfilter {



WizardLettDialog::WizardLettDialog(Window* pParent)
	: SwWizardDialog(pParent,SW_RES(DLG_WIZARD_LT),9),

	a1_Text_BrfArt(this,SW_RES(DLG_LT1_Text_BrfArt)),
	a1_RBtn_GesBrf(this,SW_RES(DLG_LT1_RBtn_GesBrf)),
	a1_RBtn_PrvBrf(this,SW_RES(DLG_LT1_RBtn_PrvBrf)),
	a1_Text_Stil  (this,SW_RES(DLG_LT1_Text_Stil  )),
	a1_RBtn_Stil1 (this,SW_RES(DLG_LT1_RBtn_Stil1 )),
	a1_RBtn_Stil2 (this,SW_RES(DLG_LT1_RBtn_Stil2 )),
	a1_RBtn_Stil3 (this,SW_RES(DLG_LT1_RBtn_Stil3 )),

	aLogo(this),

	a3_Text_AbsInp(this,SW_RES(DLG_LT3_Text_AbsInp)),
	a3_MEdt_AbsInp(this,SW_RES(DLG_LT3_MEdt_AbsInp)),
	a3_Btn_LoadAdr(this,SW_RES(DLG_LT3_Btn_LoadAdr)),
	a3_Text_AbsWdh(this,SW_RES(DLG_LT3_Text_AbsWdh)),
	a3_RBtn_WdhJaa(this,SW_RES(DLG_LT3_RBtn_WdhJaa)),
	a3_RBtn_WdhNee(this,SW_RES(DLG_LT3_RBtn_WdhNee)),
	a3_Text_AbsAnz(this,SW_RES(DLG_LT3_Text_AbsAnz)),
	a3_RBtn_AnzJaa(this,SW_RES(DLG_LT3_RBtn_AnzJaa)),
	a3_RBtn_AnzNee(this,SW_RES(DLG_LT3_RBtn_AnzNee)),
	a3_BBtn_AbsnOL(this,SW_RES(DLG_LT3_BBtn_AbsnOL)),
	a3_BBtn_AbsnOR(this,SW_RES(DLG_LT3_BBtn_AbsnOR)),
	a3_BBtn_AbsnUL(this,SW_RES(DLG_LT3_BBtn_AbsnUL)),
	a3_BBtn_AbsnUR(this,SW_RES(DLG_LT3_BBtn_AbsnUR)),
	a3_BBtn_AbsnMi(this,SW_RES(DLG_LT3_BBtn_AbsnMi)),
	a3_Text_AbsnHo(this,SW_RES(DLG_LT3_Text_AbsnHo)),
	a3_MFld_AbsnHo(this,SW_RES(DLG_LT3_MFld_AbsnHo)),
	a3_Text_AbsnVe(this,SW_RES(DLG_LT3_Text_AbsnVe)),
	a3_MFld_AbsnVe(this,SW_RES(DLG_LT3_MFld_AbsnVe)),
	a3_Text_AbsnWd(this,SW_RES(DLG_LT3_Text_AbsnWd)),
	a3_MFld_AbsnWd(this,SW_RES(DLG_LT3_MFld_AbsnWd)),
	a3_Text_AbsnHg(this,SW_RES(DLG_LT3_Text_AbsnHg)),
	a3_MFld_AbsnHg(this,SW_RES(DLG_LT3_MFld_AbsnHg)),
    a3_FL_AbsPos(this,SW_RES(DLG_LT3_FL_AbsPos)),

	aEmpf(this,FALSE,TRUE),

	a5_Text_Welche(this,SW_RES(DLG_LT5_Text_Welche)),
	a5_CBox_Elem1 (this,SW_RES(DLG_LT5_CBox_Elem1 )),
	a5_Edit_Elem1 (this,SW_RES(DLG_LT5_Edit_Elem1 )),
	a5_CBox_Elem2 (this,SW_RES(DLG_LT5_CBox_Elem2 )),
	a5_Edit_Elem2 (this,SW_RES(DLG_LT5_Edit_Elem2 )),
	a5_CBox_Elem3 (this,SW_RES(DLG_LT5_CBox_Elem3 )),
	a5_Edit_Elem3 (this,SW_RES(DLG_LT5_Edit_Elem3 )),
	a5_CBox_Elem4 (this,SW_RES(DLG_LT5_CBox_Elem4 )),
	a5_Edit_Elem4 (this,SW_RES(DLG_LT5_Edit_Elem4 )),
	a5_CBox_Datum (this,SW_RES(DLG_LT5_CBox_Datum )),
    a5_List_Datum (this,SW_RES(DLG_LT5_List_Datum ), NUMBERFORMAT_DATE, ULONG_MAX, FALSE),
	a5_CBox_Betref(this,SW_RES(DLG_LT5_CBox_Betref)),
	a5_Edit_Betref(this,SW_RES(DLG_LT5_Edit_Betref)),
	a5_CBox_KopiAn(this,SW_RES(DLG_LT5_CBox_KopiAn)),
	a5_CBox_Anlagn(this,SW_RES(DLG_LT5_CBox_Anlagn)),
	a5_CBox_PagNum(this,SW_RES(DLG_LT5_CBox_PagNum)),
	a5_Edit_PagNum(this,SW_RES(DLG_LT5_Edit_PagNum)),
	a5_List_PagNum(this,SW_RES(DLG_LT5_List_PagNum)),
	a5_CBox_PagGes(this,SW_RES(DLG_LT5_CBox_PagGes)),
	a5_Edit_PagGes(this,SW_RES(DLG_LT5_Edit_PagGes)),

	pPrinter(NULL)
{
	// set HC images
	a3_Btn_LoadAdr.SetModeImage(SW_RES(DLG_LT3_Img_LoadAdr),BMP_COLOR_HIGHCONTRAST);
	a3_BBtn_AbsnOL.SetModeImage(SW_RES(DLG_LT3_Img_AbsnOL),BMP_COLOR_HIGHCONTRAST);
	a3_BBtn_AbsnOR.SetModeImage(SW_RES(DLG_LT3_Img_AbsnOR),BMP_COLOR_HIGHCONTRAST);
	a3_BBtn_AbsnUL.SetModeImage(SW_RES(DLG_LT3_Img_AbsnUL),BMP_COLOR_HIGHCONTRAST);

	a3_BBtn_AbsnUR.SetModeImage(SW_RES(DLG_LT3_Img_AbsnUR),BMP_COLOR_HIGHCONTRAST);
	a3_BBtn_AbsnMi.SetModeImage(SW_RES(DLG_LT3_Img_AbsnMi),BMP_COLOR_HIGHCONTRAST);

	pFusz=new WizardFuszDlg(this,TRUE);
	pMarg=new WizardMargDlg(this);

	p7_Text_FolgPg=new FixedText  (this,SW_RES(DLG_LT7_Text_FolgPg));
	p7_Text_KLinOb=new FixedText  (this,SW_RES(DLG_LT7_Text_KLinOb));
	p7_MFld_KLinOb=new MetricField(this,SW_RES(DLG_LT7_MFld_KLinOb));
	p7_Text_KLinTx=new FixedText  (this,SW_RES(DLG_LT7_Text_KLinTx));
	p7_MFld_KLinTx=new MetricField(this,SW_RES(DLG_LT7_MFld_KLinTx));
	p7_Text_LogoWo=new FixedText  (this,SW_RES(DLG_LT7_Text_LogoWo));
	p7_List_LogoWo=new ListBox    (this,SW_RES(DLG_LT7_List_LogoWo));
	p7_Text_LogoWd=new FixedText  (this,SW_RES(DLG_LT7_Text_LogoWd));
	p7_MFld_LogoWd=new MetricField(this,SW_RES(DLG_LT7_MFld_LogoWd));
	p7_Text_LogoHg=new FixedText  (this,SW_RES(DLG_LT7_Text_LogoHg));
	p7_MFld_LogoHg=new MetricField(this,SW_RES(DLG_LT7_MFld_LogoHg));
	p7_Text_AbsnWo=new FixedText  (this,SW_RES(DLG_LT7_Text_AbsnWo));
	p7_List_AbsnWo=new ListBox    (this,SW_RES(DLG_LT7_List_AbsnWo));
	p7_Text_AbsnWd=new FixedText  (this,SW_RES(DLG_LT7_Text_AbsnWd));
	p7_MFld_AbsnWd=new MetricField(this,SW_RES(DLG_LT7_MFld_AbsnWd));
	p7_Text_AbsnHg=new FixedText  (this,SW_RES(DLG_LT7_Text_AbsnHg));
	p7_MFld_AbsnHg=new MetricField(this,SW_RES(DLG_LT7_MFld_AbsnHg));
    p7_FL_KopLin=new FixedLine  (this,SW_RES(DLG_LT7_FL_KopLin));
	p7_CBox_FusAnz=new CheckBox   (this,SW_RES(DLG_LT7_CBox_FusAnz));
	p7_Text_FLinOb=new FixedText  (this,SW_RES(DLG_LT7_Text_FLinOb));
	p7_MFld_FLinOb=new MetricField(this,SW_RES(DLG_LT7_MFld_FLinOb));
	p7_Text_FLinTx=new FixedText  (this,SW_RES(DLG_LT7_Text_FLinTx));
	p7_MFld_FLinTx=new MetricField(this,SW_RES(DLG_LT7_MFld_FLinTx));
    p7_FL_FusLin=new FixedLine   (this,SW_RES(DLG_LT7_FL_FusLin));

	FieldUnit aMetric = ::GetDfltMetric(FALSE);
	a3_MFld_AbsnHo.SetUnit(aMetric);
	a3_MFld_AbsnVe.SetUnit(aMetric);
	a3_MFld_AbsnWd.SetUnit(aMetric);
	a3_MFld_AbsnHg.SetUnit(aMetric);
	p7_MFld_KLinOb->SetUnit(aMetric);
	p7_MFld_KLinTx->SetUnit(aMetric);
	p7_MFld_LogoWd->SetUnit(aMetric);
	p7_MFld_LogoHg->SetUnit(aMetric);
	p7_MFld_AbsnWd->SetUnit(aMetric);
	p7_MFld_AbsnHg->SetUnit(aMetric);
	p7_MFld_FLinOb->SetUnit(aMetric);
	p7_MFld_FLinTx->SetUnit(aMetric);

	p9_BMap_Fahne =new FixedBitmap(this,SW_RES(DLG_LT9_BMap_Fahne ));
	p9_Text_WanPrn=new FixedText  (this,SW_RES(DLG_LT9_Text_WanPrn));
	p9_Text_LgoPrn=new FixedText  (this,SW_RES(DLG_LT9_Text_LgoPrn));
	p9_List_LgoPrn=new ListBox    (this,SW_RES(DLG_LT9_List_LgoPrn));
	p9_Text_AbsPrn=new FixedText  (this,SW_RES(DLG_LT9_Text_AbsPrn));
	p9_List_AbsPrn=new ListBox    (this,SW_RES(DLG_LT9_List_AbsPrn));
	p9_Text_Tip   =new FixedText  (this,SW_RES(DLG_LT9_Text_Tip   ));
	p9_Text_TipPrn=new FixedText  (this,SW_RES(DLG_LT9_Text_TipPrn));

/*	{
		// TipText ausrichten fuer anders spracheliche Versionen
		Size aSz( GetTextSize( p9_Text_Tip->GetText() ) );
		Point aPos( p9_Text_Tip->GetPosPixel() );
		aPos.X() += aSz.Width() + 3;

		aPos.Y() = p9_Text_TipPrn->GetPosPixel().Y();
		p9_Text_TipPrn->SetPosPixel( aPos );
	}*/
#ifndef NO_PAPERBIN
	p9_Text_PrTray=new FixedText  (this,SW_RES(DLG_LT9_Text_PrTray));
	p9_Text_TrayS1=new FixedText  (this,SW_RES(DLG_LT9_Text_TrayS1));
	p9_List_TrayS1=new ListBox    (this,SW_RES(DLG_LT9_List_TrayS1));
	p9_Text_TrayFF=new FixedText  (this,SW_RES(DLG_LT9_Text_TrayFF));
	p9_List_TrayFF=new ListBox    (this,SW_RES(DLG_LT9_List_TrayFF));
#endif

    p9_FL_Prn   = new FixedLine  (this,SW_RES(DLG_LT9_FL_Prn));
	p9_Btn_PrSetup = new PushButton(this,SW_RES(DLG_LT9_Btn_PrSetup));
	p9_Text_PrName = new FixedText (this,SW_RES(DLG_LT9_Text_PrName));

	a3_BBtn_AbsnOL.setBitmaps(Bitmap(SW_RES(BMAP_Disbl_AbsnOL_H)));
	a3_BBtn_AbsnOR.setBitmaps(Bitmap(SW_RES(BMAP_Disbl_AbsnOR_H)));
	a3_BBtn_AbsnUL.setBitmaps(Bitmap(SW_RES(BMAP_Disbl_AbsnUL_H)));
	a3_BBtn_AbsnUR.setBitmaps(Bitmap(SW_RES(BMAP_Disbl_AbsnUR_H)));
	a3_BBtn_AbsnMi.setBitmaps(Bitmap(SW_RES(BMAP_Disbl_AbsnMi_H)));

	a3_BBtn_AbsnOL.ChangeDisbBitmap(Bitmap(SW_RES(BMAP_Disbl_AbsnOL)),Bitmap(SW_RES(BMAP_Disbl_AbsnOL__H)));
	a3_BBtn_AbsnOR.ChangeDisbBitmap(Bitmap(SW_RES(BMAP_Disbl_AbsnOR)),Bitmap(SW_RES(BMAP_Disbl_AbsnOR__H)));
	a3_BBtn_AbsnUL.ChangeDisbBitmap(Bitmap(SW_RES(BMAP_Disbl_AbsnUL)),Bitmap(SW_RES(BMAP_Disbl_AbsnUL__H)));
	a3_BBtn_AbsnUR.ChangeDisbBitmap(Bitmap(SW_RES(BMAP_Disbl_AbsnUR)),Bitmap(SW_RES(BMAP_Disbl_AbsnUR__H)));
	a3_BBtn_AbsnMi.ChangeDisbBitmap(Bitmap(SW_RES(BMAP_Disbl_AbsnMi)),Bitmap(SW_RES(BMAP_Disbl_AbsnMi__H)));

	FreeResource();
}

WizardLettDialog::~WizardLettDialog()
{
	delete pFusz;
	delete pMarg;

	delete p7_Text_FolgPg;
	delete p7_Text_KLinOb;
	delete p7_MFld_KLinOb;
	delete p7_Text_KLinTx;
	delete p7_MFld_KLinTx;
	delete p7_Text_LogoWo;
	delete p7_List_LogoWo;
	delete p7_Text_LogoWd;
	delete p7_MFld_LogoWd;
	delete p7_Text_LogoHg;
	delete p7_MFld_LogoHg;
	delete p7_Text_AbsnWo;
	delete p7_List_AbsnWo;
	delete p7_Text_AbsnWd;
	delete p7_MFld_AbsnWd;
	delete p7_Text_AbsnHg;
	delete p7_MFld_AbsnHg;
    delete p7_FL_KopLin;
	delete p7_CBox_FusAnz;
	delete p7_Text_FLinOb;
	delete p7_MFld_FLinOb;
	delete p7_Text_FLinTx;
	delete p7_MFld_FLinTx;
    delete p7_FL_FusLin;

	delete p9_BMap_Fahne ;
	delete p9_Text_WanPrn;
	delete p9_Text_LgoPrn;
	delete p9_List_LgoPrn;
	delete p9_Text_AbsPrn;
	delete p9_List_AbsPrn;
	delete p9_Text_Tip   ;
	delete p9_Text_TipPrn;
#ifndef NO_PAPERBIN
	delete p9_Text_PrTray;
	delete p9_Text_TrayS1;
	delete p9_List_TrayS1;
	delete p9_Text_TrayFF;
	delete p9_List_TrayFF;
#endif
    delete p9_FL_Prn;
	delete p9_Btn_PrSetup;
	delete p9_Text_PrName;

	if (pPrinter)
		delete pPrinter;
}



}
