/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: tempauto.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 16:37:16 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _TEMPAUTO_HXX
#define _TEMPAUTO_HXX

// auto strip #ifndef _SVARRAY_HXX //autogen
// auto strip #include <svtools/svarray.hxx>
// auto strip #endif

// auto strip #ifndef _STRING_HXX //autogen
// auto strip #include <tools/string.hxx>
// auto strip #endif
namespace binfilter {

/*************************************************************************
 * In der folgenden Struktur werden Paare von Strings fuer die temporaere
 * Autokorrektur gehalten:
 * in aWrong das als falsch erkannte Wort,
 * in aCorrect die richtige Schreibweise.
 *************************************************************************/

//STRIP001 class SwCorrection
//STRIP001 {
//STRIP001 	String aWrong;
//STRIP001 	String aCorrect;
//STRIP001 
//STRIP001 	StringCompare _Compare( const SwCorrection& rSwCorrection ) const;
//STRIP001 public:
//STRIP001 	SwCorrection( const String& rStr ) : aWrong( rStr )	{}
//STRIP001 
//STRIP001 		  String &Correct()				{ return aCorrect; }
//STRIP001 	const String &Correct() const 		{ return aCorrect; }
//STRIP001 
//STRIP001 	BOOL Identical() const 				{ return aWrong == aCorrect; }
//STRIP001 
//STRIP001 	BOOL operator<( const SwCorrection& rSwCorrection ) const
//STRIP001 		{ return COMPARE_GREATER == _Compare( rSwCorrection ); }
//STRIP001 	BOOL operator==( const SwCorrection& rSwCorrection ) const
//STRIP001 		{ return COMPARE_EQUAL == _Compare( rSwCorrection ); }
//STRIP001 };

//STRIP001 typedef SwCorrection* SwCorrectionPtr;
//STRIP001 SV_DECL_PTRARR_SORT_DEL(SwTempList, SwCorrectionPtr, 0, 10)

/*************************************************************************
 * SwTempAuto
 * enthaelt als member eine Liste von Ersetzungspaaren (SwCorrection).
 * Gefuellt wird diese Liste mit den Worten, die ueber die Rechtschreib-
 * korrektur ersetzt werden, via Dialog (splwrp.cxx) oder rechte Maustaste
 * beim OnlineSpelling (olmenu.cxx).
 * Ausgewertet wird die Liste bei eingeschalteter Autokorrektur nach Eingabe
 * eines Blanks (edws.cxx) und ein wiederholter Schreibfehler wird sofort
 * korrigiert.
 * Die Liste wird bei Bedarf (beim ersten Ersetzen) angelegt und erst beim
 * Programmende geloescht (txtinit.cxx).
 *************************************************************************/

//STRIP001 class SwTempAuto
//STRIP001 {
//STRIP001 	SwTempList aList;
//STRIP001 public:
//STRIP001 	const SwCorrection* Replaceable( const String& rCheck ) const;
//STRIP001 	void Insert( SwCorrection* pCorr );
//STRIP001 	void Delete( const String& rCheck );
//STRIP001 };

// In TempAuto.Cxx implementiert, in olmenu.cxx und splwrp.cxx ggf. mit
// new angelegt.
//STRIP001 extern SwTempAuto *pTempAuto;


} //namespace binfilter
#endif
